# Generated by Django 2.1.3 on 2018-12-07 19:54

from django.db import migrations, models
import django.db.models.deletion
import uuid


class Migration(migrations.Migration):

    dependencies = [
        ('restapi', '0021_auto_20181110_0845'),
    ]

    operations = [
        migrations.CreateModel(
            name='API_Key',
            fields=[
                ('id', models.UUIDField(default=uuid.uuid4, editable=False, primary_key=True, serialize=False)),
                ('create_date', models.DateTimeField(auto_now_add=True)),
                ('write_date', models.DateTimeField(auto_now=True)),
                ('title', models.CharField(max_length=256, verbose_name='title')),
                ('public_key', models.CharField(max_length=256, verbose_name='public key')),
                ('private_key', models.CharField(max_length=256, verbose_name='private key')),
                ('private_key_nonce', models.CharField(max_length=64, unique=True, verbose_name='private key nonce')),
                ('secret_key', models.CharField(max_length=256, verbose_name='secret key')),
                ('secret_key_nonce', models.CharField(max_length=64, unique=True, verbose_name='secret key nonce')),
                ('user_private_key', models.CharField(max_length=256, verbose_name='user private key')),
                ('user_private_key_nonce', models.CharField(max_length=64, unique=True, verbose_name='user private key nonce')),
                ('user_secret_key', models.CharField(max_length=256, verbose_name='user secret key')),
                ('user_secret_key_nonce', models.CharField(max_length=64, unique=True, verbose_name='user secret key nonce')),
                ('verify_key', models.CharField(max_length=64, verbose_name='verify key')),
                ('read', models.BooleanField(default=True, help_text='Allows reading', verbose_name='Read right')),
                ('write', models.BooleanField(default=False, help_text='Allows writing / updating', verbose_name='Write right')),
                ('restrict_to_secrets', models.BooleanField(default=False, help_text='Allows access to only spcific secrets', verbose_name='Restrict to specific secrets')),
                ('allow_insecure_access', models.BooleanField(default=False, help_text='Allows API access insecurely without transport encryption or even server side decryption', verbose_name='Allow Insecure Access')),
                ('active', models.BooleanField(default=True, help_text='Designates whether this API key is active or not.', verbose_name='Is Active?')),
                ('user', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='api_keys', to='restapi.User')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='API_Key_Secret',
            fields=[
                ('id', models.UUIDField(default=uuid.uuid4, editable=False, primary_key=True, serialize=False)),
                ('create_date', models.DateTimeField(auto_now_add=True)),
                ('write_date', models.DateTimeField(auto_now=True)),
                ('secret_key', models.CharField(max_length=256, verbose_name='secret key')),
                ('secret_key_nonce', models.CharField(max_length=64, verbose_name='secret key nonce')),
                ('title', models.CharField(max_length=256, verbose_name='title')),
                ('title_nonce', models.CharField(max_length=64, verbose_name='title nonce')),
                ('api_key', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='api_key_secrets', to='restapi.API_Key')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.AddField(
            model_name='secret',
            name='callback_pass',
            field=models.CharField(default='', max_length=128, verbose_name='Callback Password'),
        ),
        migrations.AddField(
            model_name='secret',
            name='callback_url',
            field=models.CharField(default='', max_length=2048, verbose_name='Callback URL'),
        ),
        migrations.AddField(
            model_name='secret',
            name='callback_user',
            field=models.CharField(default='', max_length=128, verbose_name='Callback User'),
        ),
        migrations.AddField(
            model_name='secret_history',
            name='callback_pass',
            field=models.CharField(default='', max_length=128, verbose_name='Callback Password'),
        ),
        migrations.AddField(
            model_name='secret_history',
            name='callback_url',
            field=models.CharField(default='', max_length=2048, verbose_name='Callback URL'),
        ),
        migrations.AddField(
            model_name='secret_history',
            name='callback_user',
            field=models.CharField(default='', max_length=128, verbose_name='Callback User'),
        ),
        migrations.AddField(
            model_name='token',
            name='read',
            field=models.BooleanField(default=True, help_text='Read permissions', verbose_name='Read'),
        ),
        migrations.AddField(
            model_name='token',
            name='write',
            field=models.BooleanField(default=True, help_text='Write permissions', verbose_name='Write'),
        ),
        migrations.AlterField(
            model_name='group_share_right',
            name='write',
            field=models.BooleanField(default=False, help_text='Designates whether this user has "write" rights and can update this share', verbose_name='Write right'),
        ),
        migrations.AlterField(
            model_name='user_share_right',
            name='write',
            field=models.BooleanField(default=False, help_text='Designates whether this user has "write" rights and can update this share', verbose_name='Write right'),
        ),
        migrations.AddField(
            model_name='api_key_secret',
            name='secret',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='api_key_secrets', to='restapi.Secret'),
        ),
        migrations.AddField(
            model_name='token',
            name='api_key',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='tokens', to='restapi.API_Key'),
        ),
        migrations.AlterUniqueTogether(
            name='api_key_secret',
            unique_together={('api_key', 'secret')},
        ),
    ]
